diff --git a/Changelog b/Changelog
index ba5aebf79d..4c8d8a8b29 100644
--- a/Changelog
+++ b/Changelog
@@ -77,6 +77,7 @@ version <next>:
 - OpenEXR image encoder
 - Simbiosis IMX decoder
 - Simbiosis IMX demuxer
+- TTML subtitle encoder and muxer
 
 
 version 4.3:
diff --git a/doc/general_contents.texi b/doc/general_contents.texi
index 6acdf441d6..58c9bcf747 100644
--- a/doc/general_contents.texi
+++ b/doc/general_contents.texi
@@ -1352,6 +1352,7 @@ performance on systems without hardware floating point support).
 @item SubViewer v1     @tab   @tab X @tab   @tab X
 @item SubViewer        @tab   @tab X @tab   @tab X
 @item TED Talks captions @tab @tab X @tab   @tab X
+@item TTML             @tab X @tab   @tab X @tab
 @item VobSub (IDX+SUB) @tab   @tab X @tab   @tab X
 @item VPlayer          @tab   @tab X @tab   @tab X
 @item WebVTT           @tab X @tab X @tab X @tab X
diff --git a/libavcodec/Makefile b/libavcodec/Makefile
index 6ec1d360ac..4b1be2e37c 100644
--- a/libavcodec/Makefile
+++ b/libavcodec/Makefile
@@ -672,6 +672,7 @@ OBJS-$(CONFIG_TSCC_DECODER)            += tscc.o msrledec.o
 OBJS-$(CONFIG_TSCC2_DECODER)           += tscc2.o
 OBJS-$(CONFIG_TTA_DECODER)             += tta.o ttadata.o ttadsp.o
 OBJS-$(CONFIG_TTA_ENCODER)             += ttaenc.o ttaencdsp.o ttadata.o
+OBJS-$(CONFIG_TTML_ENCODER)            += ttmlenc.o ass_split.o
 OBJS-$(CONFIG_TWINVQ_DECODER)          += twinvqdec.o twinvq.o metasound_data.o
 OBJS-$(CONFIG_TXD_DECODER)             += txd.o
 OBJS-$(CONFIG_ULTI_DECODER)            += ulti.o
diff --git a/libavcodec/allcodecs.c b/libavcodec/allcodecs.c
index 354d146379..a91f19ae31 100644
--- a/libavcodec/allcodecs.c
+++ b/libavcodec/allcodecs.c
@@ -689,6 +689,7 @@ extern AVCodec ff_subviewer_decoder;
 extern AVCodec ff_subviewer1_decoder;
 extern AVCodec ff_text_encoder;
 extern AVCodec ff_text_decoder;
+extern AVCodec ff_ttml_encoder;
 extern AVCodec ff_vplayer_decoder;
 extern AVCodec ff_webvtt_encoder;
 extern AVCodec ff_webvtt_decoder;
diff --git a/libavcodec/ttmlenc.c b/libavcodec/ttmlenc.c
new file mode 100644
index 0000000000..3972b4368c
--- /dev/null
+++ b/libavcodec/ttmlenc.c
@@ -0,0 +1,210 @@
+/*
+ * TTML subtitle encoder
+ * Copyright (c) 2020 24i
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+/**
+ * @file
+ * TTML subtitle encoder
+ * @see https://www.w3.org/TR/ttml1/
+ * @see https://www.w3.org/TR/ttml2/
+ * @see https://www.w3.org/TR/ttml-imsc/rec
+ */
+
+#include "avcodec.h"
+#include "internal.h"
+#include "libavutil/avstring.h"
+#include "libavutil/bprint.h"
+#include "libavutil/internal.h"
+#include "ass_split.h"
+#include "ass.h"
+#include "ttmlenc.h"
+
+typedef struct {
+    AVCodecContext *avctx;
+    ASSSplitContext *ass_ctx;
+    AVBPrint buffer;
+} TTMLContext;
+
+static void ttml_text_cb(void *priv, const char *text, int len)
+{
+    TTMLContext *s = priv;
+    AVBPrint cur_line = { 0 };
+    AVBPrint *buffer = &s->buffer;
+
+    av_bprint_init(&cur_line, len, AV_BPRINT_SIZE_UNLIMITED);
+
+    av_bprint_append_data(&cur_line, text, len);
+    if (!av_bprint_is_complete(&cur_line)) {
+        av_log(s->avctx, AV_LOG_ERROR,
+               "Failed to move the current subtitle dialog to AVBPrint!\n");
+        av_bprint_finalize(&cur_line, NULL);
+        return;
+    }
+
+
+    av_bprint_escape(buffer, cur_line.str, NULL, AV_ESCAPE_MODE_XML,
+                     0);
+
+    av_bprint_finalize(&cur_line, NULL);
+}
+
+static void ttml_new_line_cb(void *priv, int forced)
+{
+    TTMLContext *s = priv;
+
+    av_bprintf(&s->buffer, "<br/>");
+}
+
+static const ASSCodesCallbacks ttml_callbacks = {
+    .text             = ttml_text_cb,
+    .new_line         = ttml_new_line_cb,
+};
+
+static int ttml_encode_frame(AVCodecContext *avctx, uint8_t *buf,
+                             int bufsize, const AVSubtitle *sub)
+{
+    TTMLContext *s = avctx->priv_data;
+    ASSDialog *dialog;
+    int i;
+
+    av_bprint_clear(&s->buffer);
+
+    for (i=0; i<sub->num_rects; i++) {
+        const char *ass = sub->rects[i]->ass;
+
+        if (sub->rects[i]->type != SUBTITLE_ASS) {
+            av_log(avctx, AV_LOG_ERROR, "Only SUBTITLE_ASS type supported.\n");
+            return AVERROR(EINVAL);
+        }
+
+#if FF_API_ASS_TIMING
+        if (!strncmp(ass, "Dialogue: ", 10)) {
+            int num;
+            dialog = ff_ass_split_dialog(s->ass_ctx, ass, 0, &num);
+
+            for (; dialog && num--; dialog++) {
+                int ret = ff_ass_split_override_codes(&ttml_callbacks, s,
+                                                      dialog->text);
+                int log_level = (ret != AVERROR_INVALIDDATA ||
+                                 avctx->err_recognition & AV_EF_EXPLODE) ?
+                                AV_LOG_ERROR : AV_LOG_WARNING;
+
+                if (ret < 0) {
+                    av_log(avctx, log_level,
+                           "Splitting received ASS dialog failed: %s\n",
+                           av_err2str(ret));
+
+                    if (log_level == AV_LOG_ERROR)
+                        return ret;
+                }
+            }
+        } else {
+#endif
+            dialog = ff_ass_split_dialog2(s->ass_ctx, ass);
+            if (!dialog)
+                return AVERROR(ENOMEM);
+
+            {
+                int ret = ff_ass_split_override_codes(&ttml_callbacks, s,
+                                                      dialog->text);
+                int log_level = (ret != AVERROR_INVALIDDATA ||
+                                 avctx->err_recognition & AV_EF_EXPLODE) ?
+                                AV_LOG_ERROR : AV_LOG_WARNING;
+
+                if (ret < 0) {
+                    av_log(avctx, log_level,
+                           "Splitting received ASS dialog text %s failed: %s\n",
+                           dialog->text,
+                           av_err2str(ret));
+
+                    if (log_level == AV_LOG_ERROR) {
+                        ff_ass_free_dialog(&dialog);
+                        return ret;
+                    }
+                }
+
+                ff_ass_free_dialog(&dialog);
+            }
+#if FF_API_ASS_TIMING
+        }
+#endif
+    }
+
+    if (!av_bprint_is_complete(&s->buffer))
+        return AVERROR(ENOMEM);
+    if (!s->buffer.len)
+        return 0;
+
+    // force null-termination, so in case our destination buffer is
+    // too small, the return value is larger than bufsize minus null.
+    if (av_strlcpy(buf, s->buffer.str, bufsize) > bufsize - 1) {
+        av_log(avctx, AV_LOG_ERROR, "Buffer too small for TTML event.\n");
+        return AVERROR_BUFFER_TOO_SMALL;
+    }
+
+    return s->buffer.len;
+}
+
+static av_cold int ttml_encode_close(AVCodecContext *avctx)
+{
+    TTMLContext *s = avctx->priv_data;
+
+    ff_ass_split_free(s->ass_ctx);
+
+    av_bprint_finalize(&s->buffer, NULL);
+
+    return 0;
+}
+
+static av_cold int ttml_encode_init(AVCodecContext *avctx)
+{
+    TTMLContext *s = avctx->priv_data;
+
+    s->avctx   = avctx;
+
+    if (!(s->ass_ctx = ff_ass_split(avctx->subtitle_header))) {
+        return AVERROR_INVALIDDATA;
+    }
+
+    if (!(avctx->extradata = av_mallocz(TTMLENC_EXTRADATA_SIGNATURE_SIZE +
+                                        1 + AV_INPUT_BUFFER_PADDING_SIZE))) {
+        return AVERROR(ENOMEM);
+    }
+
+    avctx->extradata_size = TTMLENC_EXTRADATA_SIGNATURE_SIZE;
+    memcpy(avctx->extradata, TTMLENC_EXTRADATA_SIGNATURE,
+           TTMLENC_EXTRADATA_SIGNATURE_SIZE);
+
+    av_bprint_init(&s->buffer, 0, AV_BPRINT_SIZE_UNLIMITED);
+
+    return 0;
+}
+
+AVCodec ff_ttml_encoder = {
+    .name           = "ttml",
+    .long_name      = NULL_IF_CONFIG_SMALL("TTML subtitle"),
+    .type           = AVMEDIA_TYPE_SUBTITLE,
+    .id             = AV_CODEC_ID_TTML,
+    .priv_data_size = sizeof(TTMLContext),
+    .init           = ttml_encode_init,
+    .encode_sub     = ttml_encode_frame,
+    .close          = ttml_encode_close,
+    .capabilities   = FF_CODEC_CAP_INIT_CLEANUP,
+};
diff --git a/libavcodec/ttmlenc.h b/libavcodec/ttmlenc.h
new file mode 100644
index 0000000000..c1dd5ec990
--- /dev/null
+++ b/libavcodec/ttmlenc.h
@@ -0,0 +1,28 @@
+/*
+ * TTML subtitle encoder shared functionality
+ * Copyright (c) 2020 24i
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef AVCODEC_TTMLENC_H
+#define AVCODEC_TTMLENC_H
+
+#define TTMLENC_EXTRADATA_SIGNATURE "lavc-ttmlenc"
+#define TTMLENC_EXTRADATA_SIGNATURE_SIZE (sizeof(TTMLENC_EXTRADATA_SIGNATURE) - 1)
+
+#endif /* AVCODEC_TTMLENC_H */
diff --git a/libavcodec/version.h b/libavcodec/version.h
index 85fbbfe766..8396d68cde 100644
--- a/libavcodec/version.h
+++ b/libavcodec/version.h
@@ -28,8 +28,8 @@
 #include "libavutil/version.h"
 
 #define LIBAVCODEC_VERSION_MAJOR  58
-#define LIBAVCODEC_VERSION_MINOR 125
-#define LIBAVCODEC_VERSION_MICRO 101
+#define LIBAVCODEC_VERSION_MINOR 126
+#define LIBAVCODEC_VERSION_MICRO 100
 
 #define LIBAVCODEC_VERSION_INT  AV_VERSION_INT(LIBAVCODEC_VERSION_MAJOR, \
                                                LIBAVCODEC_VERSION_MINOR, \
diff --git a/libavformat/Makefile b/libavformat/Makefile
index fcb39ce133..330eb83796 100644
--- a/libavformat/Makefile
+++ b/libavformat/Makefile
@@ -545,6 +545,7 @@ OBJS-$(CONFIG_TRUEHD_DEMUXER)            += rawdec.o mlpdec.o
 OBJS-$(CONFIG_TRUEHD_MUXER)              += rawenc.o
 OBJS-$(CONFIG_TTA_DEMUXER)               += tta.o apetag.o img2.o
 OBJS-$(CONFIG_TTA_MUXER)                 += ttaenc.o apetag.o img2.o
+OBJS-$(CONFIG_TTML_MUXER)                += ttmlenc.o
 OBJS-$(CONFIG_TTY_DEMUXER)               += tty.o sauce.o
 OBJS-$(CONFIG_TY_DEMUXER)                += ty.o
 OBJS-$(CONFIG_TXD_DEMUXER)               += txd.o
diff --git a/libavformat/allformats.c b/libavformat/allformats.c
index 3b69423508..8b98c68e3b 100644
--- a/libavformat/allformats.c
+++ b/libavformat/allformats.c
@@ -444,6 +444,7 @@ extern AVInputFormat  ff_truehd_demuxer;
 extern AVOutputFormat ff_truehd_muxer;
 extern AVInputFormat  ff_tta_demuxer;
 extern AVOutputFormat ff_tta_muxer;
+extern AVOutputFormat ff_ttml_muxer;
 extern AVInputFormat  ff_txd_demuxer;
 extern AVInputFormat  ff_tty_demuxer;
 extern AVInputFormat  ff_ty_demuxer;
diff --git a/libavformat/ttmlenc.c b/libavformat/ttmlenc.c
new file mode 100644
index 0000000000..940f8bbd4e
--- /dev/null
+++ b/libavformat/ttmlenc.c
@@ -0,0 +1,174 @@
+/*
+ * TTML subtitle muxer
+ * Copyright (c) 2020 24i
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+/**
+ * @file
+ * TTML subtitle muxer
+ * @see https://www.w3.org/TR/ttml1/
+ * @see https://www.w3.org/TR/ttml2/
+ * @see https://www.w3.org/TR/ttml-imsc/rec
+ */
+
+#include "avformat.h"
+#include "internal.h"
+#include "libavcodec/ttmlenc.h"
+#include "libavutil/internal.h"
+
+enum TTMLPacketType {
+    PACKET_TYPE_PARAGRAPH,
+    PACKET_TYPE_DOCUMENT,
+};
+
+typedef struct TTMLMuxContext {
+    enum TTMLPacketType input_type;
+    unsigned int document_written;
+} TTMLMuxContext;
+
+static const char ttml_header_text[] =
+"<?xml version=\"1.0\" encoding=\"utf-8\"?>\n"
+"<tt\n"
+"  xmlns=\"http://www.w3.org/ns/ttml\"\n"
+"  xmlns:ttm=\"http://www.w3.org/ns/ttml#metadata\"\n"
+"  xmlns:tts=\"http://www.w3.org/ns/ttml#styling\"\n"
+"  xml:lang=\"%s\">\n"
+"  <body>\n"
+"    <div>\n";
+
+static const char ttml_footer_text[] =
+"    </div>\n"
+"  </body>\n"
+"</tt>\n";
+
+static void ttml_write_time(AVIOContext *pb, const char tag[],
+                            int64_t millisec)
+{
+    int64_t sec, min, hour;
+    sec = millisec / 1000;
+    millisec -= 1000 * sec;
+    min = sec / 60;
+    sec -= 60 * min;
+    hour = min / 60;
+    min -= 60 * hour;
+
+    avio_printf(pb, "%s=\"%02"PRId64":%02"PRId64":%02"PRId64".%03"PRId64"\"",
+                tag, hour, min, sec, millisec);
+}
+
+static int ttml_write_header(AVFormatContext *ctx)
+{
+    TTMLMuxContext *ttml_ctx = ctx->priv_data;
+    ttml_ctx->document_written = 0;
+
+    if (ctx->nb_streams != 1 ||
+        ctx->streams[0]->codecpar->codec_id != AV_CODEC_ID_TTML) {
+        av_log(ctx, AV_LOG_ERROR, "Exactly one TTML stream is required!\n");
+        return AVERROR(EINVAL);
+    }
+
+    {
+        AVStream    *st = ctx->streams[0];
+        AVIOContext *pb = ctx->pb;
+
+        AVDictionaryEntry *lang = av_dict_get(st->metadata, "language", NULL,
+                                              0);
+        const char *printed_lang = (lang && lang->value) ? lang->value : "";
+
+        // Not perfect, but decide whether the packet is a document or not
+        // by the existence of the lavc ttmlenc extradata.
+        ttml_ctx->input_type = (st->codecpar->extradata &&
+                                st->codecpar->extradata_size >= TTMLENC_EXTRADATA_SIGNATURE_SIZE &&
+                                !memcmp(st->codecpar->extradata,
+                                        TTMLENC_EXTRADATA_SIGNATURE,
+                                        TTMLENC_EXTRADATA_SIGNATURE_SIZE)) ?
+                               PACKET_TYPE_PARAGRAPH :
+                               PACKET_TYPE_DOCUMENT;
+
+        avpriv_set_pts_info(st, 64, 1, 1000);
+
+        if (ttml_ctx->input_type == PACKET_TYPE_PARAGRAPH)
+            avio_printf(pb, ttml_header_text, printed_lang);
+    }
+
+    return 0;
+}
+
+static int ttml_write_packet(AVFormatContext *ctx, AVPacket *pkt)
+{
+    TTMLMuxContext *ttml_ctx = ctx->priv_data;
+    AVIOContext    *pb       = ctx->pb;
+
+    switch (ttml_ctx->input_type) {
+    case PACKET_TYPE_PARAGRAPH:
+        // write out a paragraph element with the given contents.
+        avio_printf(pb,     "      <p\n");
+        ttml_write_time(pb, "        begin", pkt->pts);
+        avio_w8(pb, '\n');
+        ttml_write_time(pb, "        end",   pkt->pts + pkt->duration);
+        avio_printf(pb, ">");
+        avio_write(pb, pkt->data, pkt->size);
+        avio_printf(pb, "</p>\n");
+        break;
+    case PACKET_TYPE_DOCUMENT:
+        // dump the given document out as-is.
+        if (ttml_ctx->document_written) {
+            av_log(ctx, AV_LOG_ERROR,
+                   "Attempting to write multiple TTML documents into a "
+                   "single document! The XML specification forbids this "
+                   "as there has to be a single root tag.\n");
+            return AVERROR(EINVAL);
+        }
+        avio_write(pb, pkt->data, pkt->size);
+        ttml_ctx->document_written = 1;
+        break;
+    default:
+        av_log(ctx, AV_LOG_ERROR,
+               "Internal error: invalid TTML input packet type: %d!\n",
+               ttml_ctx->input_type);
+        return AVERROR_BUG;
+    }
+
+    return 0;
+}
+
+static int ttml_write_trailer(AVFormatContext *ctx)
+{
+    TTMLMuxContext *ttml_ctx = ctx->priv_data;
+    AVIOContext    *pb       = ctx->pb;
+
+    if (ttml_ctx->input_type == PACKET_TYPE_PARAGRAPH)
+        avio_printf(pb, ttml_footer_text);
+
+    return 0;
+}
+
+AVOutputFormat ff_ttml_muxer = {
+    .name              = "ttml",
+    .long_name         = NULL_IF_CONFIG_SMALL("TTML subtitle"),
+    .extensions        = "ttml",
+    .mime_type         = "text/ttml",
+    .priv_data_size    = sizeof(TTMLMuxContext),
+    .flags             = AVFMT_GLOBALHEADER | AVFMT_VARIABLE_FPS |
+                         AVFMT_TS_NONSTRICT,
+    .subtitle_codec    = AV_CODEC_ID_TTML,
+    .write_header      = ttml_write_header,
+    .write_packet      = ttml_write_packet,
+    .write_trailer     = ttml_write_trailer,
+};
diff --git a/tests/fate/subtitles.mak b/tests/fate/subtitles.mak
index 6323d0f93d..ee65afe35b 100644
--- a/tests/fate/subtitles.mak
+++ b/tests/fate/subtitles.mak
@@ -106,6 +106,9 @@ fate-sub-scc: CMD = fmtstdout ass -ss 57 -i $(TARGET_SAMPLES)/sub/witch.scc
 FATE_SUBTITLES-$(call ALLYES, MPEGTS_DEMUXER DVBSUB_DECODER DVBSUB_ENCODER) += fate-sub-dvb
 fate-sub-dvb: CMD = framecrc -i $(TARGET_SAMPLES)/sub/dvbsubtest_filter.ts -map s:0 -c dvbsub
 
+FATE_SUBTITLES-$(call ALLYES, FILE_PROTOCOL PIPE_PROTOCOL SRT_DEMUXER SUBRIP_DECODER TTML_ENCODER TTML_MUXER) += fate-sub-ttmlenc
+fate-sub-ttmlenc: CMD = fmtstdout ttml -i $(TARGET_SAMPLES)/sub/SubRip_capability_tester.srt
+
 FATE_SUBTITLES-$(call ENCMUX, ASS, ASS) += $(FATE_SUBTITLES_ASS-yes)
 FATE_SUBTITLES += $(FATE_SUBTITLES-yes)
 
diff --git a/tests/ref/fate/sub-ttmlenc b/tests/ref/fate/sub-ttmlenc
new file mode 100644
index 0000000000..51eab97817
--- /dev/null
+++ b/tests/ref/fate/sub-ttmlenc
@@ -0,0 +1,122 @@
+<?xml version="1.0" encoding="utf-8"?>
+<tt
+  xmlns="http://www.w3.org/ns/ttml"
+  xmlns:ttm="http://www.w3.org/ns/ttml#metadata"
+  xmlns:tts="http://www.w3.org/ns/ttml#styling"
+  xml:lang="">
+  <body>
+    <div>
+      <p
+        begin="00:00:00.000"
+        end="00:00:00.000">Don't show this text it may be used to insert hidden data</p>
+      <p
+        begin="00:00:01.500"
+        end="00:00:04.500">SubRip subtitles capability tester 1.3o by ale5000<br/>Use VLC 1.1 or higher as reference for most things and MPC Home Cinema for others<br/>This text should be blue<br/>This text should be red<br/>This text should be black<br/>If you see this with the normal font, the player don't (fully) support font face</p>
+      <p
+        begin="00:00:04.500"
+        end="00:00:04.500">Hidden</p>
+      <p
+        begin="00:00:04.501"
+        end="00:00:07.500">This text should be small<br/>This text should be normal<br/>This text should be big</p>
+      <p
+        begin="00:00:07.501"
+        end="00:00:11.500">This should be an E with an accent: È<br/>日本語<br/>This text should be bold, italics and underline<br/>This text should be small and green<br/>This text should be small and red<br/>This text should be big and brown</p>
+      <p
+        begin="00:00:11.501"
+        end="00:00:14.500">This line should be bold<br/>This line should be italics<br/>This line should be underline<br/>This line should be strikethrough<br/>Both lines<br/>should be underline</p>
+      <p
+        begin="00:00:14.501"
+        end="00:00:17.500">&gt;<br/>It would be a good thing to<br/>hide invalid html tags that are closed and show the text in them<br/>but show un-closed invalid html tags<br/>Show not opened tags<br/>&lt;</p>
+      <p
+        begin="00:00:17.501"
+        end="00:00:20.500">and also<br/>hide invalid html tags with parameters that are closed and show the text in them<br/>but show un-closed invalid html tags<br/>This text should be showed underlined without problems also: 2&lt;3,5&gt;1,4&lt;6<br/>This shouldn't be underlined</p>
+      <p
+        begin="00:00:20.501"
+        end="00:00:21.500">This text should be in the normal position...</p>
+      <p
+        begin="00:00:21.501"
+        end="00:00:22.500">This text should NOT be in the normal position</p>
+      <p
+        begin="00:00:22.501"
+        end="00:00:24.500">Implementation is the same of the ASS tag<br/>This text should be at the<br/>top and horizontally centered</p>
+      <p
+        begin="00:00:22.501"
+        end="00:00:24.500">This text should be at the<br/>middle and horizontally centered</p>
+      <p
+        begin="00:00:22.501"
+        end="00:00:24.500">This text should be at the<br/>bottom and horizontally centered</p>
+      <p
+        begin="00:00:24.501"
+        end="00:00:26.500">This text should be at the<br/>top and horizontally at the left</p>
+      <p
+        begin="00:00:24.501"
+        end="00:00:26.500">This text should be at the<br/>middle and horizontally at the left<br/>(The second position must be ignored)</p>
+      <p
+        begin="00:00:24.501"
+        end="00:00:26.500">This text should be at the<br/>bottom and horizontally at the left</p>
+      <p
+        begin="00:00:26.501"
+        end="00:00:28.500">This text should be at the<br/>top and horizontally at the right</p>
+      <p
+        begin="00:00:26.501"
+        end="00:00:28.500">This text should be at the<br/>middle and horizontally at the right</p>
+      <p
+        begin="00:00:26.501"
+        end="00:00:28.500">This text should be at the<br/>bottom and horizontally at the right</p>
+      <p
+        begin="00:00:28.501"
+        end="00:00:31.500">This could be the most difficult thing to implement</p>
+      <p
+        begin="00:00:31.501"
+        end="00:00:50.500">First text</p>
+      <p
+        begin="00:00:33.500"
+        end="00:00:35.500">Second, it shouldn't overlap first</p>
+      <p
+        begin="00:00:35.501"
+        end="00:00:37.500">Third, it should replace second</p>
+      <p
+        begin="00:00:36.501"
+        end="00:00:50.500">Fourth, it shouldn't overlap first and third</p>
+      <p
+        begin="00:00:40.501"
+        end="00:00:45.500">Fifth, it should replace third</p>
+      <p
+        begin="00:00:45.501"
+        end="00:00:50.500">Sixth, it shouldn't be<br/>showed overlapped</p>
+      <p
+        begin="00:00:50.501"
+        end="00:00:52.500">TEXT 1 (bottom)</p>
+      <p
+        begin="00:00:50.501"
+        end="00:00:52.500">text 2</p>
+      <p
+        begin="00:00:52.501"
+        end="00:00:54.500">Hide these tags:<br/>also hide these tags:<br/>but show this: {normal text}</p>
+      <p
+        begin="00:00:54.501"
+        end="00:01:00.500"><br/>\ N is a forced line break<br/>\ h is a hard space<br/>Normal spaces at the start and at the end of the line are trimmed while hard spaces are not trimmed.<br/>The\hline\hwill\hnever\hbreak\hautomatically\hright\hbefore\hor\hafter\ha\hhard\hspace.\h:-D</p>
+      <p
+        begin="00:00:54.501"
+        end="00:00:56.500"><br/>\h\h\h\h\hA (05 hard spaces followed by a letter)<br/>A (Normal  spaces followed by a letter)<br/>A (No hard spaces followed by a letter)</p>
+      <p
+        begin="00:00:56.501"
+        end="00:00:58.500">\h\h\h\h\hA (05 hard spaces followed by a letter)<br/>A (Normal  spaces followed by a letter)<br/>A (No hard spaces followed by a letter)<br/>Show this: \TEST and this: \-)</p>
+      <p
+        begin="00:00:58.501"
+        end="00:01:00.500"><br/>A letter followed by 05 hard spaces: A\h\h\h\h\h<br/>A letter followed by normal  spaces: A<br/>A letter followed by no hard spaces: A<br/>05 hard  spaces between letters: A\h\h\h\h\hA<br/>5 normal spaces between letters: A     A<br/><br/>^--Forced line break</p>
+      <p
+        begin="00:01:00.501"
+        end="00:01:02.500">Both line should be strikethrough,<br/>yes.<br/>Correctly closed tags<br/>should be hidden.</p>
+      <p
+        begin="00:01:02.501"
+        end="00:01:04.500">It shouldn't be strikethrough,<br/>not opened tag showed as text.<br/>Not opened tag showed as text.</p>
+      <p
+        begin="00:01:04.501"
+        end="00:01:06.500">Three lines should be strikethrough,<br/>yes.<br/>Not closed tags showed as text</p>
+      <p
+        begin="00:01:06.501"
+        end="00:01:08.500">Both line should be strikethrough but<br/>the wrong closing tag should be showed</p>
+    </div>
+  </body>
+</tt>